#include <vncview.h>
#include <stdio.h>

int
main(int argc, char **argv)
{
	int last_retrace=0;

    printf("DOS VNC viewer v1.0 (98/09/21) by Marinos J. Yannikos (mjy@pobox.com)\n"
           "Compiled with DJGPP v2 by DJ Delorie,\n"
           "linked with Allegro 3.0 by Shawn Hargreaves\n"
           "and Waterloo TCP by Martin Granell, Michal Furmanczyk and Erick Engelke.\n"
           "Contains code (C) by Olivetti & Oracle Research Laboratory (under the GPL).\n\n"
           "Press Ctrl+Alt+Break for options.\n\n");
    allegro_init();

    if (!sockets_init())
    {
        fprintf(stderr,"Can't initialize TCP/IP stack. Please check your network configuration\n"
                       "and make sure that a packet driver has been loaded correctly.\n");
        exit(1);
    }

    processArgs(argc, argv);

    if (ConnectToRFBServer(hostname, port) == NULL) exit(1);

    if (!InitialiseRFBConnection(rfbsock)) exit(1);

    init_ui();

    if (!SetFormatAndEncodings()) {
	exit(1);
    }

    if (!SendFramebufferUpdateRequest(updateRequestX, updateRequestY,
				      updateRequestW, updateRequestH, False)) {
	exit(1);
    }

    while (True) {
	/* ... */

	process_input();

	if (sendUpdateRequest && last_retrace+3 < retrace_count)
	{
		if (!SendIncrementalFramebufferUpdateRequest()) {
		    exit(1);
		}
		last_retrace=retrace_count;
	}


        if (socket_data_available(rfbsock) > 0)
	{
		if (!HandleRFBServerMessage()) exit(1);
    	}
    }

    return 0;
}
